//#include <SFML/Graphics.hpp>
#include "Graph2.h"
#include <iostream>
#include <sstream>
#include <cstdlib>
#include <ctime>
#include <vector>

// -----------------------------------------------------------------------

int main()
{
    srand(time(0));
    unsigned wWidth = 720, wHeight = 560, margin = 60;

    RenderWindow window(VideoMode(wWidth, wHeight), "SFML works!");

    RectangleShape ftnBkgd(Vector2f(660,28));
    ftnBkgd.setFillColor(Color(86,190,20));
    ftnBkgd.setPosition(Vector2f(30,530));
    //rectShape.rotate(120);

    std::vector<Function*> fns;

    //Function f(float(margin), float(wWidth-margin), Vector2f(margin,wHeight/2), 400, 50, 50);
    //std::cout << "There are " << f.getNoP() << " points in the function." << '\n';
    /*for(int i = 0;  i < f.getNoP(); ++i)
        std::cout << '(' << f.vertices[i].position.x
                  << ',' << f.vertices[i].position.y
                  << ')' << '\n';*/

    Axis ax(0, Vector2f(margin, wHeight/2), wWidth-2*margin, 10);
    Axis ay(1, Vector2f(wWidth/2, wHeight-margin), wHeight-2*margin, 10);
    //delete[] fvals;

    Texture algebroid01;
    if(!algebroid01.loadFromFile("algebroid01.png")) return -1;
    RectangleShape rAlgebroid01(Vector2f(24,27));
    rAlgebroid01.setTexture(&algebroid01);
    rAlgebroid01.setPosition(32,530);

    Font font;
    if(!font.loadFromFile("arial.ttf"))
        std::cout << "font not loaded" << std::endl;

    window.setKeyRepeatEnabled(false);

    // set the string to display
    Text text("Y = ", font, 24);
    Text ftext("", font, 24);

    // set the character size
    //text.setCharacterSize(24); // in pixels, not points!

    // set the color
    text.setColor(Color(100,100,100)); //57,165,0));
    ftext.setColor(Color(100,100,100));

    // set the text style
    text.setStyle(sf::Text::Bold | sf::Text::Underlined);

    // set the text position
    text.setPosition(64,530);
    ftext.setPosition(112,528);

    String Text;
    std::string str;// = "Y = ";
    Clock clock;
    float t{0};

    while (window.isOpen())
    {
        clock.restart();
        Time time = clock.getElapsedTime();
        Event event;
        while (window.pollEvent(event))
        {
            if (event.type == Event::Closed)
                window.close();
            if (event.type == sf::Event::TextEntered)
            {
                if (event.text.unicode < 128)
                    std::cout << "ASCII character typed: " << static_cast<char>(event.text.unicode) << std::endl;
            }
            if (event.type == sf::Event::KeyPressed)
            {
                if (event.key.code == sf::Keyboard::Escape)
                {
                    std::cout << "the escape key was pressed" << std::endl;
                    std::cout << "control:" << event.key.control << std::endl;
                    std::cout << "alt:" << event.key.alt << std::endl;
                    std::cout << "shift:" << event.key.shift << std::endl;
                    std::cout << "system:" << event.key.system << std::endl;
                }
            }
            //if (Event.Type == sf::Event::Closed) App.Close();
            if (event.type == Event::TextEntered)
            {
                if (event.text.unicode < '~' && event.text.unicode > ' ')
                    str += static_cast<char>(event.text.unicode);
                if (event.text.unicode == 13)
                    fns.push_back(new Function(float(margin), float(wWidth-margin), Vector2f(margin,wHeight/2), 400, 50, 50, str+";"));
                    //std::cout << str.substr(3,str.length());
            }
            ftext.setString(str);
        }

        window.clear();
        //window.draw(circleShape);
        window.draw(ftnBkgd);
        //window.draw(text0);
        //window.draw(rShape);
        window.draw(text);
        window.draw(ftext);
        //window.draw(conSh);

        window.draw(ax);
        window.draw(ay);
        if(fns.size()>0) window.draw(*(fns[0]));
        t += 2500*time.asSeconds();
        if(sin(t)>0) window.draw(rAlgebroid01);
        //std::cout << "\nt = " << t;
        window.display();
    }

    return 0;
}
